var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { useSignal, inlinedQrl, useLexicalScope, useOn, useOnDocument, SSRStream, SSRRaw, Slot, _IMMUTABLE, componentQrl, useStylesScopedQrl, useWatchQrl, noSerialize, RenderOnce, SkipRender, implicit$FirstArg } from "@builder.io/qwik";
import { jsx, jsxs, Fragment } from "@builder.io/qwik/jsx-runtime";
import { isServer, isBrowser } from "@builder.io/qwik/build";
import { createContext, createElement, Component, createRef } from "react";
import { createRoot, hydrateRoot } from "react-dom/client";
import { flushSync } from "react-dom";
const SlotCtx = createContext({
  scopeId: ""
});
function main(slotEl, scopeId, RootCmp, props) {
  const newProps = getReactProps(props);
  return mainExactProps(slotEl, scopeId, RootCmp, newProps);
}
function mainExactProps(slotEl, scopeId, RootCmp, props) {
  return createElement(SlotCtx.Provider, {
    value: {
      el: slotEl,
      scopeId,
      attachedEl: void 0
    },
    children: createElement(RootCmp, {
      ...props,
      children: createElement(SlotElement, null)
    })
  });
}
class SlotElement extends Component {
  constructor() {
    super(...arguments);
    __publicField(this, "slotC", createRef());
  }
  shouldComponentUpdate() {
    return false;
  }
  componentDidMount() {
    const slotC = this.slotC.current;
    if (slotC) {
      const { attachedEl, el } = this.context;
      if (el) {
        if (!attachedEl)
          slotC.appendChild(el);
        else if (attachedEl !== slotC)
          throw new Error("already attached");
      }
    }
  }
  render() {
    return createElement("q-slotc", {
      class: this.context.scopeId,
      suppressHydrationWarning: true,
      dangerouslySetInnerHTML: {
        __html: "<!--SLOT-->"
      },
      ref: this.slotC
    });
  }
}
__publicField(SlotElement, "contextType", SlotCtx);
const getReactProps = (props) => {
  const obj = {};
  Object.keys(props).forEach((key) => {
    if (!key.startsWith("client:") && !key.startsWith(HOST_PREFIX)) {
      const normalizedKey = key.endsWith("$") ? key.slice(0, -1) : key;
      obj[normalizedKey] = props[key];
    }
  });
  return obj;
};
const getHostProps = (props) => {
  const obj = {};
  Object.keys(props).forEach((key) => {
    if (key.startsWith(HOST_PREFIX))
      obj[key.slice(HOST_PREFIX.length)] = props[key];
  });
  return obj;
};
const useWakeupSignal = (props, opts = {}) => {
  const signal = useSignal(false);
  const activate = inlinedQrl(() => {
    const [signal2] = useLexicalScope();
    return signal2.value = true;
  }, "useWakeupSignal_activate_6LYztwGzxAA", [
    signal
  ]);
  const clientOnly = !!(props["client:only"] || opts?.clientOnly);
  if (isServer) {
    if (props["client:visible"] || opts?.eagerness === "visible")
      useOn("qvisible", activate);
    if (props["client:idle"] || opts?.eagerness === "idle")
      useOnDocument("qidle", activate);
    if (props["client:load"] || clientOnly || opts?.eagerness === "load")
      useOnDocument("qinit", activate);
    if (props["client:hover"] || opts?.eagerness === "hover")
      useOn("mouseover", activate);
    if (props["client:event"])
      useOn(props["client:event"], activate);
    if (opts?.event)
      useOn(opts?.event, activate);
  }
  return [
    signal,
    clientOnly
  ];
};
const HOST_PREFIX = "host:";
async function renderFromServer(Host, reactCmp$, scopeId, props, ref, slotRef, hydrationProps) {
  const [Cmp, server] = await Promise.all([
    reactCmp$.resolve(),
    import("./server.f5cf7d4a.js")
  ]);
  const render = server.renderToString;
  const newProps = getReactProps(props);
  Object.assign(hydrationProps, newProps);
  const html = render(mainExactProps(void 0, scopeId, Cmp, newProps));
  const index = html.indexOf("<!--SLOT-->");
  if (index > 0) {
    const part1 = html.slice(0, index);
    const part2 = html.slice(index + 11);
    return /* @__PURE__ */ jsx(Host, {
      ref,
      ...getHostProps(props),
      children: /* @__PURE__ */ jsx(SSRStream, {
        children: async function* () {
          yield /* @__PURE__ */ jsx(SSRRaw, {
            data: part1
          }, "0a_0");
          yield /* @__PURE__ */ jsx("q-slot", {
            ref: slotRef,
            children: /* @__PURE__ */ jsx(Slot, {}, "0a_1")
          });
          yield /* @__PURE__ */ jsx(SSRRaw, {
            data: part2
          }, "0a_2");
        }
      }, "0a_3")
    }, "0a_4");
  }
  return /* @__PURE__ */ jsxs(Fragment, {
    children: [
      /* @__PURE__ */ jsx(Host, {
        ref,
        children: /* @__PURE__ */ jsx(SSRRaw, {
          data: html,
          [_IMMUTABLE]: {
            data: _IMMUTABLE
          }
        }, "0a_5")
      }, "0a_6"),
      /* @__PURE__ */ jsx("q-slot", {
        ref: slotRef,
        children: /* @__PURE__ */ jsx(Slot, {}, "0a_7")
      })
    ]
  }, "0a_8");
}
function qwikifyQrl(reactCmp$, opts) {
  return /* @__PURE__ */ componentQrl(inlinedQrl((props) => {
    const [opts2, reactCmp$2] = useLexicalScope();
    const { scopeId } = useStylesScopedQrl(inlinedQrl(`q-slot{display:none} q-slotc,q-slotc>q-slot{display:contents}`, "qwikifyQrl_component_useStylesScoped_bHjzplUVBNo"));
    const hostRef = useSignal();
    const slotRef = useSignal();
    const internalState = useSignal();
    const [signal, isClientOnly] = useWakeupSignal(props, opts2);
    const hydrationKeys = {};
    const TagName = opts2?.tagName ?? "qwik-react";
    useWatchQrl(inlinedQrl(async ({ track }) => {
      const [hostRef2, hydrationKeys2, internalState2, isClientOnly2, props2, reactCmp$3, scopeId2, signal2, slotRef2] = useLexicalScope();
      const trackedProps = track(() => ({
        ...props2
      }));
      track(signal2);
      if (!isBrowser)
        return;
      if (internalState2.value) {
        if (internalState2.value.root)
          internalState2.value.root.render(main(slotRef2.value, scopeId2, internalState2.value.cmp, trackedProps));
      } else {
        let root = void 0;
        const Cmp = await reactCmp$3.resolve();
        const hostElement = hostRef2.value;
        if (hostElement) {
          if (isClientOnly2)
            root = createRoot(hostElement);
          else
            root = flushSync(() => {
              return hydrateRoot(hostElement, mainExactProps(slotRef2.value, scopeId2, Cmp, hydrationKeys2));
            });
          if (isClientOnly2 || signal2.value === false)
            root.render(main(slotRef2.value, scopeId2, Cmp, trackedProps));
        }
        internalState2.value = noSerialize({
          cmp: Cmp,
          root
        });
      }
    }, "qwikifyQrl_component_useWatch_x04JC5xeP1U", [
      hostRef,
      hydrationKeys,
      internalState,
      isClientOnly,
      props,
      reactCmp$2,
      scopeId,
      signal,
      slotRef
    ]));
    if (isServer && !isClientOnly) {
      const jsx$1 = renderFromServer(TagName, reactCmp$2, scopeId, props, hostRef, slotRef, hydrationKeys);
      return /* @__PURE__ */ jsx(RenderOnce, {
        children: jsx$1
      }, "6S_0");
    }
    return /* @__PURE__ */ jsxs(RenderOnce, {
      children: [
        /* @__PURE__ */ jsx(TagName, {
          ...getHostProps(props),
          ref: (el) => {
            if (isBrowser)
              queueMicrotask(() => {
                const internalData = internalState.value;
                if (internalData && !internalData.root) {
                  const root = internalData.root = createRoot(el);
                  root.render(main(slotRef.value, scopeId, internalData.cmp, props));
                }
              });
            else
              hostRef.value = el;
          },
          children: SkipRender,
          [_IMMUTABLE]: {
            ref: _IMMUTABLE
          }
        }, "6S_1"),
        /* @__PURE__ */ jsx("q-slot", {
          ref: slotRef,
          children: /* @__PURE__ */ jsx(Slot, {}, "6S_2")
        })
      ]
    }, "6S_3");
  }, "qwikifyQrl_component_zH94hIe0Ick", [
    opts,
    reactCmp$
  ]));
}
const qwikify$ = /* @__PURE__ */ implicit$FirstArg(qwikifyQrl);
export {
  qwikify$,
  qwikifyQrl
};
